Attribute VB_Name = "ODBC"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                VBDEMO.BAS                             '
'                 ODBC Visual Basic Sample Application                '
'                                                                      '
' -- (C) Copyright 1991, 1992 by Microsoft Corporation                                        '
'                                                                      '
' Uses ODBC drivers, June 1992 Spec                                     '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'''''''''''''''''''''''
' Windows API declarations and constants

Type rectangle
  Left As Integer
  Top As Integer
  Right As Integer
  Bottom As Integer
End Type

Global Const DT_TOP = 0
Global Const DT_LEFT = 0
Global Const DT_CENTER = &H1
Global Const DT_RIGHT = &H2
Global Const DT_VCENTER = &H4
Global Const DT_BOTTOM = &H8
Global Const DT_WORDBREAK = &H10
Global Const DT_SINGLELINE = &H20
Global Const DT_EXPANDTABS = &H40
Global Const DT_TABSTOP = &H80
Global Const DT_NOCLIP = &H100
Global Const DT_EXTERNALLEADING = &H200
Global Const DT_CALCRECT = &H400
Global Const DT_NOPREFIX = &H800
Global Const DT_INTERNAL = &H1000

Global Const SRCCOPY = &HCC0020

Global Const ES_PASSWORD = &H20
Global Const WM_USER = 1024
Global Const EM_SETPASSWORD = WM_USER + 28
Global Const EM_SETTABSTOPS = WM_USER + 27
Global Const GWL_STYLE = -16

Declare Sub DrawText Lib "User32" (ByVal hDC As Integer, ByVal text As String, ByVal length As Integer, Box As rectangle, ByVal Formcode As Integer)
Declare Sub BitBlt Lib "Gdi32" (ByVal hDestDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal w As Integer, ByVal h As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwRop As Long)

Declare Function GetWindowLong Lib "User32" (ByVal hwnd%, ByVal nIndex%) As Long
Declare Function SetWindowLong Lib "User32" (ByVal hwnd%, ByVal nIndex%, ByVal NewLong&) As Long
Declare Function SendMessage Lib "User32" (ByVal hwnd%, ByVal Msg%, ByVal wp%, lp As Any) As Long
Declare Function GetFocus Lib "User32" () As Integer
Declare Function GetParent Lib "User32" (ByVal hwnd%) As Integer
Declare Function GetDialogBaseUnits Lib "User32" () As Long

Declare Sub SetCapture Lib "User32" (ByVal hwnd As Integer)
Declare Sub ReleaseCapture Lib "User32" ()

