VERSION 5.00
Begin VB.Form frmConnect 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Connect"
   ClientHeight    =   3150
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   4980
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3150
   ScaleWidth      =   4980
   ShowInTaskbar   =   0   'False
   Begin VB.Frame frame1 
      Caption         =   "Options"
      Height          =   1455
      Left            =   3120
      TabIndex        =   8
      Top             =   240
      Width           =   1695
      Begin VB.CheckBox chkSTRDBMON 
         Caption         =   "STRDBMON"
         Height          =   375
         Left            =   120
         TabIndex        =   11
         Top             =   960
         Width           =   1335
      End
      Begin VB.CheckBox chkSTRDBG 
         Caption         =   "STRDBG"
         Height          =   375
         Left            =   120
         TabIndex        =   10
         Top             =   600
         Width           =   975
      End
      Begin VB.CheckBox chkODBCLog 
         Caption         =   "Start ODBC log"
         Height          =   375
         Left            =   120
         TabIndex        =   9
         Top             =   240
         Width           =   1455
      End
   End
   Begin VB.TextBox txtPwd 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   1200
      PasswordChar    =   "*"
      TabIndex        =   5
      Top             =   2160
      Width           =   1815
   End
   Begin VB.TextBox txtUserID 
      Height          =   285
      Left            =   1200
      TabIndex        =   4
      Top             =   1680
      Width           =   1815
   End
   Begin VB.ComboBox lstDSN 
      Height          =   1155
      Left            =   120
      Sorted          =   -1  'True
      Style           =   1  'Simple Combo
      TabIndex        =   3
      Top             =   360
      Width           =   2895
   End
   Begin VB.CommandButton CancelButton 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2880
      TabIndex        =   1
      Top             =   2640
      Width           =   855
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   1080
      TabIndex        =   0
      Top             =   2640
      Width           =   975
   End
   Begin VB.Label Label3 
      Caption         =   "Password:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2160
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Userid:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1800
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Data Source:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "frmConnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public SelectedDSN As String
Dim myReg As New CRegAPI


Private Sub CancelButton_Click()
   SelectedDSN = ""
   Me.Hide
End Sub

Private Sub Form_Activate()
   LoadDSNs
End Sub

Private Sub Form_Load()
   'LoadDSNs
End Sub

Private Sub LoadDSNs()
Dim pcbDesc As Integer
Dim pcbDSN As Integer
Dim fDirection As Integer
Dim rc As Long
Dim szDSN As String
Dim szDesc As String
Dim sLastDSN As String
Dim lIndexLastDSN As Long
Dim I As Long

   
   'Query the last DSN used from the registry
   myReg.Root = Hkey_Current_User   'Set the root of our registry key
   On Error Resume Next          'This will raise an exception while in running in the ide
                                 'if the reg keydoesn't exist.  In the exe the Resume next will work.
   sLastDSN = myReg.QueryValue(gRegPath, "LAST_DSN")
   
   
   'Populate the list box (sorted)
   On Error GoTo DspErr
   lstDSN.Clear
   fDirection = SQL_FETCH_FIRST
   lIndexLastDSN = -1
   Do
      szDSN = Space(40)
      szDesc = Space(512)
      rc = SQLDataSources(ghEnv, fDirection, szDSN, Len(szDSN), pcbDSN, szDesc, Len(szDesc), pcbDesc)
      If rc <> SQL_SUCCESS Then Exit Do
      If InStr(1, szDesc, "Client Access", vbTextCompare) > 0 Then
         szDSN = Left(szDSN, pcbDSN)      'Trim null
         Debug.Print szDSN
         lstDSN.AddItem szDSN
      End If
      fDirection = SQL_FETCH_NEXT
   Loop While rc = SQL_SUCCESS
      
   'Select the last DSN used
   For I = 0 To lstDSN.ListCount - 1
      lstDSN.ListIndex = I
      If StrComp(lstDSN.Text, sLastDSN, vbTextCompare) = 0 Then
         lstDSN.ListIndex = I 'lIndexLastDSN
         'lIndexLastDSN = lstDSN.ListCount - 1
         Exit For
      End If
   Next I
   
   

   Exit Sub
DspErr:
   MsgBox "Exception in frmConnect.Load. " & Err.Description, vbOKOnly, gAppName
   
LoadExit:
      
End Sub

Private Sub OKButton_Click()
   SelectedDSN = lstDSN.Text
   myReg.SetKeyValue gRegPath, "LAST_DSN", lstDSN.Text, REG_SZ
   Me.Hide
End Sub
