VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmDBMON 
   Caption         =   "DBMON Analysis"
   ClientHeight    =   7350
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6630
   LinkTopic       =   "Form1"
   ScaleHeight     =   7350
   ScaleWidth      =   6630
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cmdlg 
      Left            =   6000
      Top             =   6600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CheckBox chkLongName 
      Caption         =   "Column Text as field name"
      Height          =   255
      Left            =   360
      TabIndex        =   16
      Top             =   6360
      Value           =   1  'Checked
      Width           =   2415
   End
   Begin VB.CommandButton Command2 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   3908
      TabIndex        =   5
      Top             =   6720
      Width           =   1215
   End
   Begin VB.TextBox txtSQL 
      Height          =   975
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   10
      TabStop         =   0   'False
      Top             =   4560
      Width           =   6135
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "Execute"
      Height          =   375
      Left            =   1508
      TabIndex        =   4
      Top             =   6720
      Width           =   1215
   End
   Begin VB.ComboBox cboQueries 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   5880
      Width           =   6135
   End
   Begin VB.Frame Frame1 
      Caption         =   "DBMON File Information"
      Height          =   2415
      Left            =   240
      TabIndex        =   8
      Top             =   1800
      Width           =   6135
      Begin VB.CommandButton cmdDltLF 
         Caption         =   "Delete Logicals"
         Height          =   375
         Left            =   3608
         TabIndex        =   2
         Top             =   1800
         Width           =   1695
      End
      Begin VB.TextBox txtDBMONOutFile 
         Height          =   285
         Left            =   3480
         TabIndex        =   6
         Text            =   "*CURLIB/QAQQDBMN"
         Top             =   360
         Width           =   2535
      End
      Begin VB.TextBox txtLibName 
         Height          =   285
         Left            =   3480
         TabIndex        =   0
         Text            =   "QGPL"
         Top             =   1320
         Width           =   2535
      End
      Begin VB.CommandButton Command1 
         Caption         =   "Create Logicals"
         Height          =   375
         Left            =   1328
         TabIndex        =   1
         Top             =   1800
         Width           =   1695
      End
      Begin VB.TextBox txtFileName 
         Height          =   285
         Left            =   3480
         TabIndex        =   7
         Text            =   "DBMONSRC"
         Top             =   840
         Width           =   2535
      End
      Begin VB.Label Label4 
         Caption         =   "DBMON Outfile:"
         Height          =   255
         Left            =   360
         TabIndex        =   13
         Top             =   390
         Width           =   1695
      End
      Begin VB.Label Label2 
         Caption         =   "Library for Logicals:"
         Height          =   255
         Left            =   360
         TabIndex        =   11
         Top             =   1350
         Width           =   2055
      End
      Begin VB.Label Label1 
         Caption         =   "SRCPF file name (holds source DDS):"
         Height          =   255
         Left            =   360
         TabIndex        =   9
         Top             =   870
         Width           =   3015
      End
   End
   Begin VB.Label Label7 
      Caption         =   "In R430 and later use the DBMON functions integrated into Operations Navigator"
      ForeColor       =   &H000000FF&
      Height          =   255
      Left            =   240
      TabIndex        =   17
      Top             =   1560
      Width           =   6135
   End
   Begin VB.Label Label6 
      Caption         =   "SQL Statement for Query:"
      Height          =   255
      Left            =   240
      TabIndex        =   15
      Top             =   4320
      Width           =   2295
   End
   Begin VB.Label Label5 
      Caption         =   "DBMON Query:"
      Height          =   255
      Left            =   240
      TabIndex        =   14
      Top             =   5640
      Width           =   2055
   End
   Begin VB.Label Label3 
      Caption         =   $"frmDBMON.frx":0000
      Height          =   1335
      Left            =   240
      TabIndex        =   12
      Top             =   120
      Width           =   6135
   End
End
Attribute VB_Name = "frmDBMON"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long


Private LFNames() As String                'LFs created over DBMON
Private Type tDBMONQueries
   Description As String
   Query As String
   WrapOption As Boolean
   NoRenaming As Boolean      'do not rename fields
End Type
Private DBMONQueries() As tDBMONQueries
Private WithEvents DBMONLF As SrcPF
Attribute DBMONLF.VB_VarHelpID = -1

Private Sub cboQueries_Click()
Dim S As String

If cboQueries.ListIndex <> -1 Then
      txtSQL.Text = FixString(DBMONQueries(cboQueries.ListIndex).Query, _
                              txtLibName.Text, _
                              DBMONQueries(cboQueries.ListIndex).WrapOption, _
                              DBMONQueries(cboQueries.ListIndex).NoRenaming)
      'Select Case cboQueries.ListIndex
      'E'nd Select
   End If
   

End Sub

Private Sub cmdDltLF_Click()
   Dim S As String
   Dim S1 As String
   Dim I As Integer
   
   S = "The following files will be deleted: " & vbCrLf
   For I = 0 To UBound(LFNames)
      S = S & "     " & txtLibName & "/" & LFNames(I) & vbCrLf
   Next I
   If MsgBox(S, vbOKCancel, gAppName) = vbCancel Then Exit Sub
      
   S1 = "Results of the delete operation: " & vbCrLf
   For I = 0 To UBound(LFNames)
      S = "DLTF " & txtLibName & "/" & LFNames(I)
      rc = RmtCmd(S, True)
      S1 = S1 & "     " & txtLibName & "/" & LFNames(I) & ":  " & rc & vbCrLf
   Next I
  MsgBox S1, vbOKOnly, gAppName

End Sub

Private Sub cmdExecute_Click()
   Dim S As String
   Dim hStmt As Long

   'Try to avoid adding same stmt ran twice
'   If StrComp(txtSQL.Text, cboSQL.Text, 1) <> 0 Then
'      'Add new item to the list
'      cboSQL.AddItem txtSQL.Text  'cboSQL.Text
'      cboSQL.ListIndex = cboSQL.ListCount - 1
'   End If
   
   'Execute the statement
   rc = SQLAllocStmt(ghDbc, hStmt)
   If (rc <> SQL_SUCCESS And rc <> SQL_SUCCESS_WITH_INFO) Then
      PrintError ghDbc, 0
      '.Text = Str(rc)
      Exit Sub
   End If

   Screen.MousePointer = vbHourglass
   
   
   rc = SQLExecDirect(hStmt, txtSQL.Text, SQL_NTS)
   If (rc = SQL_ERROR) Then GoTo errSQLExecute
   
   If InStr(1, txtSQL.Text, "SELECT", 1) > 0 Or _
      InStr(1, txtSQL.Text, "CALL", 1) > 0 Then
      rc = GetDataAll(hStmt)
   End If
      
   rc = SQLFreeStmt(hStmt, SQL_DROP)
   Screen.MousePointer = 0
   'txtRC.Text = "Stmt ran successfully"
   Exit Sub
   
errSQLExecute:
   Screen.MousePointer = 0
   PrintError ghDbc, hStmt
   rc = SQLFreeStmt(hStmt, SQL_DROP)
   'txtRC.Text = "Stmt Failed"

End Sub

Private Sub Command1_Click()
   
   Dim Src() As String
   Dim S As String
   Dim I As Long
   Dim J As Integer, K As Integer
   Dim Status As String
   Dim PCFileName As String      'File Name of DDS Source
   Dim PathName As String        'Path to DDS Source


'   ReDim Src(55) As String
'   Src(0) = "     A* DATABASE MONITOR LOGICAL FILE 1000"
'   Src(1) = "     A          R QQQ1000                   PFILE(*CURLIB/QAQQDBMN)"
'   Src(2) = "     A QQRID"
'   Src(3) = "     A QQTIME"
'   Src(4) = "     A QQJFLD"
'   Src(5) = "     A QQRDBN"
'   Src(6) = "     A QQSYS"
'   Src(7) = "     A QQJOB"
'   Src(8) = "     A QQUSER"
'   Src(9) = "     A QQJNUM"
'   Src(10) = "     A            QQTHRD                    RENAME(QQI9) +"
'   Src(11) = "                                            COLHDG('THREAD' +"
'   Src(12) = "                                                   'IDENTIFIER')"
'   Src(13) = "     A QQUCNT"
'   Src(14) = "     A            QQRCNT                    RENAME(QQI5) +"
'   Src(15) = "                                            COLHDG('REFRESH' +"
'   Src(16) = "                                                   'COUNTER')"
'   Src(17) = "     A QQUDEF"
'   Src(18) = "     A QQSTN"
'   Src(19) = "     A            QQSTF                     RENAME(QQC11) +"
'   Src(20) = "                                            COLHDG('STATEMENT' +"
'   Src(21) = "                                                   'FUNCTION')"
'   Src(22) = "     A            QQSTOP                     RENAME(QQC21) +"
'   Src(23) = "                                            COLHDG('STATEMENT' +"
'   Src(24) = "                                                   'OPERATION')"
'   Src(25) = "     A            QQSTTY                    RENAME(QQC12) +"
'   Src(26) = "                                            COLHDG('STATEMENT' 'TYPE')"
'   Src(27) = "     A            QQPARS                    RENAME(QQC13) +"
'   Src(28) = "                                            COLHDG('PARSE' 'REQUIRED')"
'   Src(29) = "     A            QQPNAM                    RENAME(QQC103) +"
'   Src(30) = "                                            COLHDG('PACKAGE' 'NAME')"
'   Src(31) = "     A            QQPLIB                    RENAME(QQC104) +"
'   Src(32) = "                                            COLHDG('PACKAGE' 'LIBRARY')"
'   Src(33) = "     A            QQCNAM                    RENAME(QQC181) +"
'   Src(34) = "                                            COLHDG('CURSOR' 'NAME')"
'   Src(35) = "     A            QQSNAM                    RENAME(QQC182) +"
'   Src(36) = "                                            COLHDG('STATEMENT' 'NAME')"
'   Src(37) = "     A            QQSTIM"
'   Src(38) = "     A            QQSTTX                    RENAME(QQ1000) +"
'   Src(39) = "                                            COLHDG('STATEMENT' 'TEXT')"
'   Src(40) = "     A            QQSTOC                    RENAME(QQC14) +"
'   Src(41) = "                                            COLHDG('STATEMENT' +"
'   Src(42) = "                                                   'OUTCOME')"
'   Src(43) = "     A            QQROWR                    RENAME(QQI2) +"
'   Src(44) = "                                            COLHDG('ROWS' 'RETURNED')"
'   Src(45) = "     A            QQDYNR                    RENAME(QQC22) +"
'   Src(46) = "                                            COLHDG('DYNAMIC' 'REPLAN')"
'   Src(47) = "     A            QQDACV                    RENAME(QQC16) +"
'   Src(48) = "                                            COLHDG('DATA' 'CONVERSION')"
'   Src(49) = "     A            QQTTIM                    RENAME(QQI4) +"
'   Src(50) = "                                            COLHDG('TOTAL' 'TIME')"
'   Src(51) = "     A            QQROWF                    RENAME(QQI3) +"
'   Src(52) = "                                            COLHDG('ROWS' 'FETCHED')"
'   Src(53) = "     A QQETIM"
'   Src(54) = "     A          K QQJFLD"
'   Src(55) = "     A          S QQRID                     CMP(EQ 1000)"
   
'Get the path to the DDS source
PCFileName = Space(512)
rc = GetModuleFileName(0, PCFileName, Len(PCFileName))
If rc > 0 Then
   PathName = Left$(PCFileName, rc)                     'strips trailing nulls
   K = 0 'start at first position
   Do
      J = K
      K = InStr(K + 1, PathName, "\")
   Loop Until K = 0  'loop until find last "\"
   PathName = UCase$(Left$(PathName, J - 1)) & "\DBMON\"
End If


Set DBMONLF = New SrcPF
Status = "The results of the LF creation are: " & vbCrLf
For I = 0 To UBound(LFNames)
   
   'Find the source file
   On Error Resume Next
   rc = 0
   rc = FileLen(PathName & LFNames(I) & ".txt")
   If rc = 0 Then
      'Prompt to find file
      cmdlg.CancelError = True
      cmdlg.Filter = "DDS Source (*.txt)|*.txt|AllFiles (*.*)|*.*"
      cmdlg.DefaultExt = ".txt"
      cmdlg.DialogTitle = "DDS Source file for " & LFNames(I)
      cmdlg.InitDir = PathName
      On Error GoTo CreateExit
      cmdlg.ShowOpen    ' display Save common dialog box
      'if no exception then ok pressed
      PCFileName = cmdlg.FileName
      PathName = PCFileName
      K = 0 'start at first position
      Do
         J = K
         K = InStr(K + 1, PathName, "\")
      Loop Until K = 0  'loop until find last "\"
      PathName = UCase$(Left$(PathName, J - 1)) & "\"
   End If

   
   Me.MousePointer = vbHourglass
   DoEvents
   DBMONLF.ODBC_hdbc = ghDbc
   DBMONLF.SrcPFFileName = Trim(txtFileName)
   DBMONLF.SrcPFLibName = Trim(txtLibName)
   DBMONLF.SrcPFMbrName = LFNames(I)
   DBMONLF.SrcPFMbrType = "LF"
   DBMONLF.SourceType = SrcPF_PCfile       'File
   DBMONLF.MBROPT = SrcPF_REPLACE
   DBMONLF.PCFileName = PathName & LFNames(I) & ".txt"
   rc = DBMONLF.UploadSrc
   'CRTLF FILE(*CURLIB/QQQ1000) SRCFILE(*CURLIB/DBMONSRC) SRCMBR(*FILE)
   S = "CRTLF FILE(" & DBMONLF.SrcPFLibName & "/" & DBMONLF.SrcPFMbrName & ")" & _
         " SRCFILE(" & DBMONLF.SrcPFLibName & "/" & DBMONLF.SrcPFFileName & ") "
   rc = RmtCmd(S)
   If rc <> 0 Then GoTo CreateExit
   If rc = 0 Then
      Status = Status & vbTab & DBMONLF.SrcPFLibName & "/" & DBMONLF.SrcPFMbrName & vbTab & _
      " CREATED" & vbCrLf
   Else
      Status = Status & vbTab & DBMONLF.SrcPFLibName & "/" & DBMONLF.SrcPFMbrName & vbTab & _
      " FAILED" & vbCrLf
   End If
   
Next I
CreateExit:
If Len(Status) <> 0 Then MsgBox Status, vbOKOnly, gAppName
Me.MousePointer = 0
Set DBMONLF = Nothing

End Sub

Private Sub Command2_Click()
   Unload Me
End Sub

Private Sub Form_Load()
   Dim I As Long
   Dim S As String
   
   'LFs that are created with R410
   ReDim LFNames(13) As String
   LFNames(0) = "QQQ1000"
   LFNames(1) = "QQQ3000"
   LFNames(2) = "QQQ3001"
   LFNames(3) = "QQQ3002"
   LFNames(4) = "QQQ3003"
   LFNames(5) = "QQQ3004"
   LFNames(6) = "QQQ3005"
   LFNames(7) = "QQQ3006"
   LFNames(8) = "QQQ3007"
   LFNames(9) = "QQQ3008"
   LFNames(10) = "QQQ3010"
   LFNames(11) = "QQQ3014"
   LFNames(12) = "QQQ3018"
   LFNames(13) = "QQQ3019"
      
      
   ReDim DBMONQueries(100) As tDBMONQueries    'Size to max
   '******************************************************************************
   'Add new queries here
   '******************************************************************************
   I = 0
   DBMONQueries(I).Description = "Statement Summary"
   DBMONQueries(I).Query = "SELECT * " & _
               " FROM LIB/QQQ1000 order by qqstim "       'select * from JOHNSCO1.qqq1000 order by qqstim
   DBMONQueries(I).WrapOption = False

   I = I + 1
   DBMONQueries(I).Description = "Queries in your SQL application that are implemented with table scans"
   DBMONQueries(I).Query = "SELECT A.QQTLN, A.QQTFN, A.QQTOTR, A.QQIDXA, B.QQROWR, " & _
               "(B.QQETIM - B.QQSTIM) AS TOT_TIME, B.QQSTTX FROM LIB/QQQ3000 A, " & _
               "LIB/QQQ1000 B WHERE A.QQJFLD = B.QQJFLD AND A.QQUCNT = B.QQUCNT"
   DBMONQueries(I).WrapOption = True

   I = I + 1
   DBMONQueries(I).Description = "Queries with Index advised optimizer hint"
   S = "select CASE a.QQRID " & _
         "WHEN 3000 THEN 'Arrival Sequence Used'  " & _
         "WHEN 3001 THEN 'Existing Index Used'  " & _
         "WHEN 3002 THEN 'Temp Index created'  " & _
         "WHEN 3003 THEN 'Query Sort Used'  " & _
         "WHEN 3004 THEN 'Temporary Result Set Used'  " & _
         "ELSE CHAR(a.QQRID)  " & _
         "END as ""Record Id"", " & _
         " a.qqucnt as ""Count"", qqtln as ""Library"",  " & _
         " qqtfn as ""Table"", qqept as ""Estimated Processing Time"", " & _
         " qqttim as ""Total Time (ms)"",  "
   S = S & "qqi2 as ""Advised Primary Index Keys"",  " & _
      " qqidxd as ""Index Advised Key Columns"", " & _
      " qq1000 as ""Created Index Keys"", CASE QQRCOD  " & _
      "WHEN 'I1' THEN 'Record Selection'  " & _
      "WHEN 'I2' THEN 'ORDER BY or GROUP BY'  " & _
      "WHEN 'I3' THEN 'Record Selection and ORDER BY or GROUP BY'  " & _
      "WHEN 'I4' THEN 'Nested Loop Join'  " & _
      "WHEN 'I5' THEN 'Record Selection Using Bitmap Processing'  " & _
      "ELSE QQRCOD  " & _
      "END as ""Reason Code"", " & _
      "b.qqsttx as ""SQL Stmt"", " & _
      "b.qqstop as ""Stmt Op""    " & _
      "from LIB/qaqqdbmn a left outer join LIB/qqq1000 b on a.qqjfld = b.qqjfld and b.qqstop = 'OP' " & _
      "where qqidxa = 'Y' order by ""Count"" "
   DBMONQueries(I).Query = S
   'DBMONQueries(I).Query = "SELECT A.QQTLN, A.QQTFN, A.QQIDXA, A.QQIDXD, A.QQIDXK, " & _
                  "B.QQOPID, C.QQSTTX FROM LIB/QQQ3000 A INNER JOIN " & _
                  "LIB/QQQ3014 B ON (A.QQJFLD = B.QQJFLD AND A.QQUCNT = " & _
                  "B.QQUCNT) LEFT OUTER JOIN LIB/QQQ1000 C ON (A.QQJFLD " & _
                  "= C.QQJFLD AND A.QQUCNT = C.QQUCNT) WHERE A.QQIDXA = 'Y'"
   DBMONQueries(I).WrapOption = False
   DBMONQueries(I).NoRenaming = True
   I = I + 1
   DBMONQueries(I).Description = "How many queries are performing dynamic replans?"
   DBMONQueries(I).Query = "SELECT COUNT(*) as ""Num dynamic replans"" From LIB/QQQ1000 WHERE  QQDYNR <> 'NA'"
   DBMONQueries(I).WrapOption = True

   I = I + 1
   DBMONQueries(I).Description = "What is the statement text and the reason for the dynamic replans?"
   DBMONQueries(I).Query = "SELECT QQDYNR, QQSTTX From LIB/QQQ1000 WHERE  QQDYNR <> 'NA'"
   DBMONQueries(I).WrapOption = True
   'Note: You have to refer to the description of field QQDYNR for definitions of the dynamic replan reason codes.
   
   I = I + 1
   DBMONQueries(I).Description = "How many indexes have been created over LIB1/TBL1?"
   DBMONQueries(I).Query = "SELECT COUNT(*)as ""Num Indexes"" From LIB/QQQ3002 WHERE  QQTLN = 'LIB1' AND  QQTFN = 'TBL1'"
   DBMONQueries(I).WrapOption = True

   I = I + 1
   DBMONQueries(I).Description = "What key fields are used for all indexes created over LIB1/TBL1 and what is the associated SQL statement text?"
   DBMONQueries(I).Query = "SELECT A.QQTLN, A.QQTFN, A.QQIDXD, B.QQSTTX FROM   LIB/QQQ3002 A, LIB/QQQ1000 B Where a.QQJFLD = B.QQJFLD AND  A.QQUCNT = B.QQUCNT " & _
      "AND  A.QQTLN  = 'LIB1' " & _
      "AND  A.QQTFN  = 'TBL1'"
   DBMONQueries(I).WrapOption = True
   'Note: This query shows key fields only from queries executed using SQL.
   
   I = I + 1
   DBMONQueries(I).Description = "What key fields are used for all indexes created over LIB1/TBL1 and what was the associated SQL statement text or query open ID?"
   DBMONQueries(I).Query = "SELECT A.QQTLN, A.QQTFN, A.QQIDXD, " & _
      "B.QQOPID , c.QQSTTX " & _
      "FROM   LIB/QQQ3002 A INNER JOIN LIB/QQQ3014 B  " & _
           "ON (A.QQJFLD = B.QQJFLD AND  " & _
            "   A.QQUCNT = B.QQUCNT) " & _
           "LEFT OUTER JOIN LIB/QQQ1000 C " & _
           "ON (A.QQJFLD = C.QQJFLD AND " & _
            "   A.QQUCNT = C.QQUCNT) " & _
         "WHERE  A.QQTLN  = 'LIB1' " & _
         "AND  A.QQTFN  = 'TBL1' "
   DBMONQueries(I).WrapOption = False
   'Note: This query shows key fields from all queries on the system.
   
   I = I + 1
   DBMONQueries(I).Description = "What types of SQL statements are being performed? Which are performed most frequently?"
   DBMONQueries(I).Query = "SELECT QQSTOP, COUNT(*) " & _
      "From LIB/QQQ1000 " & _
      "GROUP BY QQSTOP " & _
      "ORDER BY 2 DESC "
   DBMONQueries(I).WrapOption = True
   
   I = I + 1
   DBMONQueries(I).Description = "Which SQL queries are the most time consuming? Which user is running these queries?"
   DBMONQueries(I).Query = "SELECT (QQETIM - QQSTIM)as ""Time used"", QQUSER, QQSTTX " & _
      "From LIB/QQQ1000 " & _
      "ORDER BY 1 DESC "
   DBMONQueries(I).WrapOption = True
   
   I = I + 1
   DBMONQueries(I).Description = "Which queries are the most time consuming?"
   DBMONQueries(I).Query = "SELECT (A.QQTTIM + B.QQCLKT), A.QQOPID, C.QQSTTX " & _
      "FROM   LIB/QQQ3014 A LEFT OUTER JOIN LIB/QQQ3019 B " & _
           "ON (A.QQJFLD = B.QQJFLD AND " & _
            "   A.QQUCNT = B.QQUCNT) " & _
           "LEFT OUTER JOIN LIB/QQQ1000 C " & _
           "ON (A.QQJFLD = C.QQJFLD AND " & _
            "   A.QQUCNT = C.QQUCNT) " & _
         "ORDER BY 1 DESC "
   DBMONQueries(I).WrapOption = False
   'Note: This example assumes detail data has been collected into record QQQ3019.

   I = I + 1
   DBMONQueries(I).Description = "Show the data for all SQL queries with the data for each SQL query logically grouped together."
   DBMONQueries(I).Query = "SELECT A.* " & _
      "FROM   LIB/PERFDATA A, LIB/QQQ1000 B " & _
      "Where a.QQJFLD = B.QQJFLD " & _
      "AND  A.QQUCNT = B.QQUCNT "
   DBMONQueries(I).WrapOption = False
   'Note: This might be used within a report that will format the the interesting data into a more readable format. For example, all reason code fields could be expanded by the report to print the definition of the reason code (i.e., physical field QQRCOD = 'T1' means a table scan was performed because no indexes exist over the queried file).

   I = I + 1
   DBMONQueries(I).Description = "How many queries are being implemented with temporary files because a key length of greater than 2000 bytes or more than 120 key fields was specified for ordering?"
   DBMONQueries(I).Query = "SELECT COUNT(*)as ""Num Queries"" " & _
               "From LIB/QQQ3004 " & _
               "WHERE  QQRCOD = 'F6' "
   DBMONQueries(I).WrapOption = False
   
   I = I + 1
   DBMONQueries(I).Description = "Which SQL queries were implemented with nonreusable ODPs?"
   '   cboQueries.AddItem "Which SQL queries were implemented with nonreusable ODPs?"
   DBMONQueries(I).Query = "SELECT B.QQSTTX " & _
            "FROM   LIB/QQQ3010 A, LIB/QQQ1000 B " & _
            "Where a.QQJFLD = B.QQJFLD " & _
              "AND  A.QQUCNT = B.QQUCNT " & _
              "AND  A.QQODPI = 'N' "
   DBMONQueries(I).WrapOption = False

   I = I + 1
   DBMONQueries(I).Description = "What is the estimated time for all queries stopped by the query governor?"
   DBMONQueries(I).Query = "SELECT QQEPT, QQOPID " & _
       "From LIB/QQQ3014 " & _
      "WHERE  QQGVNS = 'Y'"
   DBMONQueries(I).WrapOption = False
   'Note: This example assumes detail data has been collected into record QQQ3019.

   I = I + 1
   DBMONQueries(I).Description = "Which queries estimated time exceeds actual time?"
   DBMONQueries(I).Query = "SELECT A.QQEPT, (A.QQTTIM + B.QQCLKT), A.QQOPID, " & _
      "c.QQTTIM , c.QQSTTX " & _
      " FROM   LIB/QQQ3014 A LEFT OUTER JOIN LIB/QQQ3019 B " & _
      " ON (A.QQJFLD = B.QQJFLD AND " & _
      " A.QQUCNT = B.QQUCNT) " & _
      " LEFT OUTER JOIN LIB/QQQ1000 C " & _
      " ON (A.QQJFLD = C.QQJFLD AND " & _
      " A.QQUCNT = C.QQUCNT) " & _
      " Where a.QQEPT / 1000 > (a.QQTTIM + B.QQCLKT)"
   DBMONQueries(I).WrapOption = False
   'Note: This example assumes detail data has been collected into record QQQ3019.

   I = I + 1
   DBMONQueries(I).Description = "Should a PTF for queries that perform UNION exists be applied. It should be applied if any queries are performing UNION. Do any of the queries perform this function?"
   DBMONQueries(I).Query = "SELECT COUNT(*) " & _
      " From QQQ3014 " & _
     " WHERE  QQUNIN = 'Y'"
   DBMONQueries(I).WrapOption = False
          
   I = I + 1
   DBMONQueries(I).Description = "Query to check for access plan reuse (sort by stmt, then query time)"
   DBMONQueries(I).Query = "SELECT (QQETIM - QQSTIM) as ""Time used"", QQTIME, " & _
      "QQDYNR, QQSTTX " & _
      " From LIB/QQQ1000 ORDER BY 4, 1 DESC "
   DBMONQueries(I).WrapOption = False

   ReDim Preserve DBMONQueries(I) As tDBMONQueries
   For I = LBound(DBMONQueries) To UBound(DBMONQueries)
      cboQueries.AddItem DBMONQueries(I).Description
   Next I
   cboQueries.ListIndex = 0

End Sub

Private Function FixString(SQLStmt As String, LibName As String, _
                           Optional Wrap As Boolean, _
                           Optional NoRenaming As Boolean = False) _
                            As String
'Fix up SQL queries so they look nice and replace LIB/ with specified library.

   Dim I As Integer, J As Integer
   Dim S As String
   Dim ColText() As Variant
   Dim FieldName As String
   Dim FromPosition As Integer
   Dim LastSpace As Integer
   
   S = SQLStmt
   'Replace LIB/ with library in text box
   Do
      I = InStr(1, S, "LIB/", vbTextCompare)
      If I <> 0 Then
         S = Mid$(S, 1, I - 1) & LibName & "." & Mid$(S, I + 4)
      End If
   Loop Until I = 0
   
   'Replace column names with column text
   'This is a hack used because it is such a pain to retrieve column remarks for the result set.
   'SQLColAttributes does not return table/owner for the field so you can't just do a
   'SQLColumns call to get the remarks w/o figuring out the correlations.
   'SQLColumns SQL_COLUMN_LABEL works but you can't do a LABEL ON for a logical file.
   If chkLongName = vbChecked And Not NoRenaming Then
      SetColText ColText
      For J = 0 To UBound(ColText)
         FromPosition = InStr(1, S, " FROM ", vbTextCompare)
         FieldName = Mid$(ColText(J), 1, InStr(1, ColText(J), " ") - 1)
         I = InStr(1, S, FieldName, vbTextCompare)
         'if Field name found before the FROM clause
         If I <> 0 And I < FromPosition Then
            'Avoid field name = substring of another field name
            If Mid(S, I + Len(FieldName), 1) = "," Or Mid(S, I + Len(FieldName), 1) = " " Then
               'Avoid changing calculated fields.  We'll assume calcualated
               If Not InParen(S, I) Then
                  S = Mid$(S, 1, I - 1) & ColText(J) & """ " & Mid$(S, I + Len(FieldName))
               End If
            End If
         End If
      Next J
   End If

   'Add in some line feeds but can't add line feed between quoted SQL names (i.e "long Field Name"
   I = 1
   Dim LastCrLF As Integer
   If Wrap Then
      While I <> 0
         I = InStr(I + 1, S, " ")                 'find next space
         'Only include spaces not in double quotes
         If I > LastCrLF + 60 Then
            S = Mid$(S, 1, LastSpace) & vbCrLf & Mid$(S, LastSpace + 1)
            LastCrLF = LastSpace
         End If
         If I > 0 And NumQuotesEven(S, I) Then
            LastSpace = I
         End If
      Wend
   End If
      
   FixString = S
End Function

Private Sub txtLibName_Change()
   cboQueries.ListIndex = -1         'Need to call fix string again for new lib name...
   txtSQL.Text = ""
End Sub

Private Sub DBMONLF_ModifyRecord(InputRec As String)
   Dim S As String
   'When used to upload DBMON LFs would like a quick dirty way of modifing he DDS to
   'use something other then *CURLIB.  This is it...
   
   S = InputRec
   If InStr(1, S, "PFILE(*CURLIB/QAQQDBMN)", vbTextCompare) > 0 Then
      S = Mid(S, 1, InStr(1, S, "PFILE(*CURLIB/QAQQDBMN)", vbTextCompare) - 1)
      S = S & "PFILE(" & UCase$(Trim$(txtDBMONOutFile.Text)) & ")"
   End If
   InputRec = S
End Sub
Private Sub SetColText(S As Variant)
'lookup table of DBMON short field name to Long name


ReDim S(107)

S(0) = "QQAJN as ""Estimated Number of Joined Rows"
S(1) = "QQDSS as ""Data Space Selection"
S(2) = "QQEPT as ""Estimated Processing Time"
S(3) = "QQETIM as ""End Time"
S(4) = "QQFKEY as ""Estimated Entries for Key Positioning"
S(5) = "QQGRPG as ""Grouping"
S(6) = "QQHSTV as ""Host Variables"
S(7) = "QQIDXA as ""Index Advised"
S(8) = "QQIDXD as ""Advised Key Fields"
S(9) = "QQIFNM as ""Index Name"
S(10) = "QQILNM as ""Index Lib"
S(11) = "QQIMNM as ""Index Member"
S(12) = "QQI5 as ""Refresh Count"""
S(13) = "QQI9 as ""Thread Identifier"
S(14) = "QQJFLD as ""Join Field"
S(15) = "QQJNG as ""Join"
S(16) = "QQJNP as ""Join Position"
S(17) = "QQJNUM as ""Job Number"
S(18) = "QQJOB as ""Job Name"
S(19) = "QQKP as ""Key Positioning"
S(20) = "QQKS as ""Key Selection"
S(21) = "QQKSEL as ""Estimated Entries for Key Selection"
S(22) = "QQMATL as ""Nested Level of Views Subselect"
S(23) = "QQMATN as ""Subselect of Materialized View"
S(24) = "QQNLNM as ""NLSS Lib"
S(25) = "QQNTNM as ""NLSS Table"
S(26) = "QQORDG as ""Ordering"
S(27) = "QQPTFN as ""Name of Physical File"
S(28) = "QQPTLN as ""Lib of Physical File"
S(29) = "QQPTMN as ""Member of Physical File"
S(30) = "QQQDTL as ""Nested Level of Subselect"
S(31) = "QQQDTN as ""Subselect Number"
S(32) = "QQRCDS as ""Record Selection"
S(33) = "QQRCOD as ""Reason Code"
S(34) = "QQRDBN as ""Relational Database Name"
S(35) = "QQREST as ""Estimated Number of Rows Selected"
S(36) = "QQRID as ""Record ID"
S(37) = "QQRIDX as ""Number of Entries in Index Created "
S(38) = "QQRSS as ""Number of Rows Selected"
S(39) = "QQSTIM as ""Start Time"
S(40) = "QQSTN as ""Statement Number  "
S(41) = "QQSUBQ as ""Subquery"
S(42) = "QQSYS as ""System Name"
S(43) = "QQTFN as ""File Name"
S(44) = "QQTIME as ""Created Time"
S(45) = "QQTIM1 as ""QQTIM1"
S(46) = "QQTIM2 as ""QQTIM2"
S(47) = "QQTLN as ""Lib Name"
S(48) = "QQTMN as ""Member Name"
S(49) = "QQTMPR as ""Number of Rows in Temporary"
S(50) = "QQTOTR as ""Total Rows"
S(51) = "QQUCNT as ""Unique Counter"
S(52) = "QQUDEF as ""User Defined Field"
S(53) = "QQUNIN as ""Union"
S(54) = "QQUSER as ""Job User"

S(55) = "QQRCNT as ""Refresh Counter"""
S(56) = "QQSTF as ""Stmt Function"""
S(57) = "QQSTOP as ""Stmt Operation"""
S(58) = "QQSTTY as ""Stmt Type"""
S(59) = "QQPARS as ""Parse Req"""
S(60) = "QQPNAM as ""Pkg Name"""
S(61) = "QQCNAM as ""Cursor Name"
S(62) = "QQSNAM as ""Statement Name"
S(63) = "QQSTTX as ""Statement Text"
S(64) = "QQSTOC as ""Statement Outcome"
S(65) = "QQROWR as ""Rows Returned"
S(66) = "QQDYNR as ""Dynamic Replan"
S(67) = "QQDACV as ""Data Conversion"
S(68) = "QQTTIM as ""Total Time"
S(69) = "QQROWF as ""Rows  Fetched"

S(70) = "QQJNDS as ""Data Space Number"
S(71) = "QQJNMT as ""Join Method"
S(72) = "QQJNTY as ""Join Type"
S(73) = "QQJNOP as ""Join Operator"
S(74) = "QQIDXK as ""Advised Primary Keys"
S(75) = "QQKPN as ""Number of Key Positioning Fields"
S(76) = "QQCRTK as ""Key Fields of Index Created"

S(77) = "QQSSIZ as ""Size of Sort Space"
S(78) = "QQPSIZ as ""Pool Size"
S(79) = "QQPID as ""Pool ID"
S(80) = "QQIBUF as ""Internal Buffer Length"
S(81) = "QQEBUF as ""External Buffer Length"


S(82) = "QQDFVL as ""Default Values"
S(83) = "QQLCKF as ""Lock Indicator"
S(84) = "QQULCK as ""Unlock request"

S(85) = "QQIDXN as ""Index Names"
S(86) = "QQTOUT as ""Optimizer Timed Out"

S(87) = "QQORGQ as ""Original number of QDTs"
S(88) = "QQMRGQ as ""Nubmer of QDTs Merged"

S(89) = "QQRCNT as ""Refresh Counter"
S(90) = "QQODPI as ""ODP Implementation"
S(91) = "QQHVI as ""Host Variable Implementation"
S(92) = "QQHVAR as ""Host Variable Values"

S(93) = "QQTTIM as ""ODP Open Time"
S(94) = "QQGVNE as ""Query Governor Enabled"
S(95) = "QGVNS as ""Stopped by Query Governor"
S(96) = "QQOPID as ""Query Open ID"

S(97) = "QQJOBT as ""Job Type"
S(98) = "QQCMDT as ""Command Type"
S(99) = "QQJOBI as ""Job Info"

S(100) = "QQCPUT as ""Record Retrieval CPU Time"
S(101) = "QQCLKT as ""Record Retrieval Clock Time"
S(102) = "QQSYNR as ""Sync Reads"
S(103) = "QQSYNW as ""Sync Writes"
S(104) = "QQASYR as ""Asynch Reads"
S(105) = "QQASYW as ""Asynch Writes"
S(106) = "QQRCDR as ""Records Returned"
S(107) = "QQGETC as ""Number of GETs"

End Sub

Private Function NumQuotesEven(S As String, LastPos As Integer) As Boolean
'Returns if number of double quote occurances in a string (from 1 to LastPos) is
'even or odd.

'Used to prevent line breaks in the middle of a delimited field name/alias

Dim I As Integer
Dim NumQuotes As Integer

I = 1
NumQuotes = 0
Do
   I = InStr(I + 1, S, """")
   If I <> 0 And I < LastPos Then NumQuotes = NumQuotes + 1
Loop Until I = 0 Or I > LastPos

If NumQuotes Mod 2 = 0 Then
   NumQuotesEven = True
Else
   NumQuotesEven = False
End If
End Function
Private Function InParen(S As String, FieldPos As Integer) As Boolean
'Doesn't care about nested parens...
Dim ClosePos As Integer
Dim OpenPos As Integer
Dim I As Integer

InParen = False
ClosePos = 1
Do
   OpenPos = InStr(ClosePos, S, "(")
   If OpenPos <> 0 Then
      ClosePos = InStr(OpenPos, S, ")")
   Else
      ClosePos = 0
   End If
   If (FieldPos > OpenPos) And (FieldPos < ClosePos) Then InParen = True
Loop Until OpenPos = 0 Or InParen = True
End Function

