VERSION 5.00
Begin VB.Form frmAboutBox 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "About ODBC API Test"
   ClientHeight    =   4410
   ClientLeft      =   4410
   ClientTop       =   4125
   ClientWidth     =   6225
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4410
   ScaleWidth      =   6225
   Begin VB.TextBox Text1 
      Height          =   2535
      Left            =   240
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   840
      Width           =   5775
   End
   Begin VB.CommandButton btnOK 
      Caption         =   "&OK"
      Height          =   375
      Left            =   4440
      TabIndex        =   0
      Top             =   3720
      Width           =   1095
   End
   Begin VB.Label lblVersion 
      Caption         =   "Version 1.4, Visual Basic 6.0"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   3600
      Width           =   2895
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Client Access ODBC Sample Program"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   1440
      TabIndex        =   2
      Top             =   120
      Width           =   3135
   End
   Begin VB.Label Label1 
      Caption         =   "Dave Dilling (ddilling@us.ibm.com)"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   3960
      Width           =   3855
   End
End
Attribute VB_Name = "frmAboutBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub btnOK_Click()
   Unload Me
End Sub

Private Sub Form_Load()
   Dim CRLF As String
   Dim S As String
   lblVersion.Caption = "Version " & App.Major & "." & App.Minor & "." & _
                        App.Revision & ", Visual Basic 6.0"
   
   CRLF = Chr$(13) + Chr$(10)
   S = "This sample program demonstrates how to perform various tasks "
   S = S & "using Client Access ODBC and direct ODBC API calls.  The "
   S = S & "program also includes a few functions that can be used "
   S = S & "as debug/diagnostic aids.  "
   S = S & "The code and any special instructions for the task are "
   S = S & "included in the menu options click procedure."
   S = S & vbCrLf
   S = S & "Most tests use either a file called CUSTCDT or "
   S = S & "QCUSTCDT in the default library (as specifed in "
   S = S & "the DSN).  Examples include using block inserts, "
   S = S & "using parameter markers, updating by cursor position, "
   S = S & "retrieving result set data, and calling various stored "
   S = S & "procedures.  " & CRLF
   S = S & CRLF
   S = S & "You can use the  menu options under Table Mgmt to "
   S = S & "create the tables." & CRLF
   S = S & " - QCUSTCDT has the same field layout as QIWS/QCUSTCDT" + CRLF
   S = S & " - CUSTCDT has only a subset of fields" & CRLF
   S = S & " - If you wish to run tests requiring isolation level greater " & CRLF
   S = S & "   then *NONE, you will need to create a Journal Receiver " & CRLF
   S = S & "   (CRTJRNRCV), a journal (CRTJRN) and then journal the files " & CRLF
   S = S & "   (STRJRNPF)." & CRLF
   S = S & CRLF
   S = S & "Use the  menu options: " & vbCrLf
   S = S & "Insert, Insert w/PM to populate the CUSTCDT table" & vbCrLf
   S = S & "Insert, Block Insert to populate the QCUSTCDT "
   S = S & "table." & vbCrLf
   S = S & CRLF
   S = S & "The  menu option, Misc, Crt/Dlt Procedure contains the "
   S = S & "SQL statements to create or drop a stored procedure program "
   S = S & "used in this sample.  The source code for the stored procedures "
   S = S & "is contained in the comments of the menu item's function.  You "
   S = S & "must copy the code to the 400 and compile it to create the "
   S = S & "program objects." & vbCrLf
   S = S & CRLF
   
   S = S & "Utilities" & vbCrLf
   S = S & "The  menu option Misc, AS/400 Command uses a Stored Procedure "
   S = S & "call of QCMDEXC to run AS400 CL commands." & vbCrLf
   S = S & "The menu option Misc, SQL Execute Direct allows you to run any "
   S = S & "SQL statement (w/o parameter markers).  If a result set is "
   S = S & "returned it is displayed in the list view control." & CRLF
   S = S & "The menu options under Catalog APIs can be used to check catalog "
   S = S & "information of libraries, tables and views, columns, and "
   S = S & "stored procedures." & CRLF
   S = S & CRLF
   S = S & "This module contains code made available by IBM Corporation on "
   S = S & "an AS IS basis. "
   S = S & "A user of the module should understand that IBM cannot provide "
   S = S & "technical support for the module and will not be responsible for "
   S = S & "any consequences of use of the program. " & vbCrLf
   S = S & vbCrLf
   S = S & vbCrLf
   S = S & "Comments regarding this sample program can be sent to "
   S = S & "ddilling@us.ibm.com.   "
   S = S & "Bug fixes and requests for new examples will be made as time allows. "
   S = S & vbCrLf

   Text1.Text = S
End Sub

