Attribute VB_Name = "ODBCOR_M"
'
'|========================================================================|
'| ODBC Module Core Definitions                                           |
'|========================================================================|
'
'  ODBC Core API's Definitions
'
Declare Function SQLAllocConnect Lib "odbc32.dll" (ByVal env As Long, hdbc As Long) As Integer
Declare Function SQLAllocEnv Lib "odbc32.dll" (env As Long) As Integer
Declare Function SQLAllocStmt Lib "odbc32.dll" (ByVal hdbc As Long, hStmt As Long) As Integer
Declare Function SQLBindCol Lib "odbc32.dll" (ByVal hStmt As Long, _
                                             ByVal icol As Integer, _
                                             ByVal fCType As Integer, _
                                             ByVal rgbValue As Any, _
                                             ByVal cbValueMax As Long, _
                                             pcbValue As Any) As Integer
Declare Function SQLBindColc Lib "odbc32.dll" Alias "SQLBindCol" _
                                             (ByVal hStmt As Long, _
                                             ByVal icol As Integer, _
                                             ByVal fCType As Integer, _
                                             rgbValue As Byte, _
                                             ByVal cbValueMax As Long, _
                                             pcbValue As Any) As Integer

Declare Function SQLCancel Lib "odbc32.dll" (ByVal hStmt As Long) As Integer
Declare Function SQLColAttributes Lib "odbc32.dll" (ByVal hStmt&, ByVal icol%, ByVal fDescType%, rgbDesc As Any, ByVal cbDescMax%, pcbDesc%, pfDesc&) As Integer
Declare Function SQLConnect Lib "odbc32.dll" (ByVal hdbc As Long, ByVal Server As String, ByVal serverlen As Integer, ByVal uid As String, ByVal uidlen As Integer, ByVal pwd As String, ByVal pwdlen As Integer) As Integer
Declare Function SQLDescribeCol Lib "odbc32.dll" (ByVal hStmt As Long, _
                                                   ByVal colnum As Integer, _
                                                   ByVal colname As String, _
                                                   ByVal Buflen As Integer, _
                                                   colnamelen As Integer, _
                                                   dtype As Integer, _
                                                   dl As Long, _
                                                   ds As Integer, _
                                                   n As Integer) As Integer
Declare Function SQLDisconnect Lib "odbc32.dll" (ByVal hdbc As Long) As Integer
Declare Function SQLError Lib "odbc32.dll" (ByVal env As Long, ByVal hdbc As Long, ByVal hStmt As Long, ByVal SQLState As String, NativeError As Long, ByVal Buffer As String, ByVal Buflen As Integer, Outlen As Integer) As Integer
Declare Function SQLExecDirect Lib "odbc32.dll" (ByVal hStmt As Long, _
                                             ByVal sqlString As String, _
                                             ByVal sqlstrlen As Long) As Integer
Declare Function SQLExecute Lib "odbc32.dll" (ByVal hStmt As Long) As Integer

Declare Function SQLFetch Lib "odbc32.dll" (ByVal hStmt As Long) As Integer
Declare Function SQLFreeConnect Lib "odbc32.dll" (ByVal hdbc As Long) As Integer
Declare Function SQLFreeEnv Lib "odbc32.dll" (ByVal env As Long) As Integer
Declare Function SQLFreeStmt Lib "odbc32.dll" (ByVal hStmt As Long, ByVal EndOption As Integer) As Integer
Declare Function SQLGetCursorName Lib "odbc32.dll" (ByVal hStmt As Long, ByVal szCursor As String, ByVal cbCursorMax As Integer, pcbCursor As Long) As Integer
Declare Function SQLNumResultCols Lib "odbc32.dll" (ByVal hStmt As Long, _
                                                   NumCols As Integer) As Integer
Declare Function SQLPrepare Lib "odbc32.dll" (ByVal hStmt As Long, ByVal szSqlStr As String, ByVal cbSqlStr As Long) As Integer
Declare Function SQLRowCount Lib "odbc32.dll" (ByVal hStmt As Long, pcrow As Long) As Integer
Declare Function SQLSetCursorName Lib "odbc32.dll" (ByVal hStmt As Long, ByVal szCursor As String, ByVal cbCursor As Integer) As Integer
Declare Function SQLSetParam Lib "odbc32.dll" (ByVal hStmt&, ByVal ipar%, ByVal fCType%, ByVal fSqlType%, ByVal cbColDef&, ByVal ibScale%, rgbValue As Any, pcbValue As Long) As Integer
Declare Function SQLTransact Lib "odbc32.dll" (ByVal henv As Long, ByVal hdbc As Long, ByVal fType As Integer) As Integer

