VERSION 5.00
Begin VB.Form frmCDProc 
   Caption         =   "Stored Procedure Management"
   ClientHeight    =   3420
   ClientLeft      =   3840
   ClientTop       =   2280
   ClientWidth     =   7845
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3420
   ScaleWidth      =   7845
   Begin VB.CommandButton cmdOK 
      Caption         =   "E&xit"
      Height          =   495
      Left            =   3240
      TabIndex        =   1
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Caption         =   "Stored Procedure Command"
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   7455
      Begin VB.ComboBox lstSPCmd 
         Height          =   1935
         Left            =   240
         Style           =   1  'Simple Combo
         TabIndex        =   5
         Top             =   360
         Width           =   5895
      End
      Begin VB.TextBox txtRC 
         Height          =   375
         Left            =   6600
         TabIndex        =   3
         Top             =   1680
         Width           =   735
      End
      Begin VB.CommandButton cmdExecute 
         Caption         =   "&Execute"
         Height          =   495
         Left            =   6360
         TabIndex        =   2
         Top             =   480
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "Last RC:"
         Height          =   255
         Left            =   6600
         TabIndex        =   4
         Top             =   1320
         Width           =   735
      End
   End
End
Attribute VB_Name = "frmCDProc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub cmdExecute_Click()
   Dim S As String
   Dim sSQLStmt As String
   Dim hStmt As Long
   

   rc = SQLAllocStmt(ghDbc, hStmt)
   If (rc <> SQL_SUCCESS And rc <> SQL_SUCCESS_WITH_INFO) Then
      PrintError ghDbc, 0
      Exit Sub
   End If

   S = lstSPCmd.Text    'List(lstSPCmd.ListIndex)
   If Len(S) = 0 Then
      MsgBox "You must select a procedure", , gAppName
      Exit Sub
   End If

   Screen.MousePointer = vbHourglass
   rc = SQLExecDirect(hStmt, S, SQL_NTS)
   If (rc = SQL_ERROR) Then
      PrintError ghDbc, hStmt
      'MsgBox "Execute Failed for: "
   Else
      MsgBox S & "   Executed successfully", , gAppName
   End If
   txtRC.Text = Str(rc)
   rc = SQLFreeStmt(hStmt, SQL_DROP)
   Screen.MousePointer = 0

End Sub

Private Sub cmdOK_Click()
   Unload Me
End Sub


Private Sub Form_Load()
Dim S As String


   lstSPCmd.AddItem "create procedure SPCLINOUT (INOUT :HV1 CHAR(10), INOUT :HV2 DEC(8,2)) EXTERNAL NAME SPCLINOUT LANGUAGE CL GENERAL"
   lstSPCmd.AddItem "drop procedure SPCLINOUT "
   lstSPCmd.AddItem "create procedure CDYNDAVE (IN :SQLIN CHAR(500)) RESULT SET 1 EXTERNAL NAME CDYNDAVE LANGUAGE C GENERAL"
   lstSPCmd.AddItem "create procedure CDYNDAVE (IN :SQLIN CHAR(500)) RESULT SET 1 EXTERNAL NAME CDYNDAVE LANGUAGE RPGLE GENERAL"
   lstSPCmd.AddItem "drop procedure CDYNDAVE"
   lstSPCmd.AddItem "create procedure RS2 (IN :SQLIN INTEGER) RESULT SET 2 EXTERNAL NAME RS2 LANGUAGE C GENERAL"
   lstSPCmd.AddItem "drop procedure RS2 "
   lstSPCmd.AddItem "Create Procedure Storedp2 (:Custnum in integer, :Custname out char(35), :Address out char(35), :City out char(25), :State out char(2), :Phone out char(15), :Status out char(1)) (External name storedp2 language cobol General)"
   lstSPCmd.AddItem "Drop Procedure Storedp2"
   lstSPCmd.AddItem "Create Procedure RSARRAY1C (in char(512)) RESULT SET 1 External name RSARRAY1C language C General"
   lstSPCmd.AddItem "Drop Procedure RSARRAY1C"
   lstSPCmd.AddItem "Create Procedure RSARRAY2C (in INTEGER) RESULT SET 1 External name RSARRAY2C language C General"
   lstSPCmd.AddItem "Drop Procedure RSARRAY2C"
   lstSPCmd.AddItem "Create Procedure RSARRAY2CB () RESULT SET 1 External name RSARRAY2CB language COBOL General"
   lstSPCmd.AddItem "Drop Procedure RSARRAY2CB"
   lstSPCmd.AddItem "Create Procedure RSARRAY3CB () RESULT SET 1 External name RSARRAY3CB language COBOL General"
   lstSPCmd.AddItem "Drop Procedure RSARRAY3CB"
   lstSPCmd.AddItem "Create Procedure RSARRAY3C (in char(512)) RESULT SET 1 External name RSARRAY3C language C General"
   lstSPCmd.AddItem "Drop Procedure RSARRAY3C"
   lstSPCmd.AddItem "Create procedure RPGARY RESULT SET 1 EXTERNAL NAME RPGARY LANGUAGE RPGLE GENERAL"
   lstSPCmd.AddItem "Drop Procedure RPGARY"
   
   '*********************************************************************************************
   ' V4 SQL Procedure Examples
   '*********************************************************************************************
   lstSPCmd.AddItem "Create Procedure SQLTEST1 (IN Custno INTEGER, IN CrtIncr NUMERIC(4,0)) LANGUAGE SQL " & _
            "SQLTest1Src: " & _
            "BEGIN " & _
            "UPDATE QCUSTCDT SET CDTLMT = CDTLMT + CrtIncr WHERE CUSNUM = custno;" & _
            "END "
   lstSPCmd.AddItem "Drop Procedure SQLTEST1"
   
   'Simple result set
   lstSPCmd.AddItem "Create Procedure SQLTESTRS1 ()RESULT SET 1 LANGUAGE SQL " & _
            "SQLTestSrc: " & _
            "BEGIN " & _
            "DECLARE C1 CURSOR FOR SELECT * FROM CUSTCDT; " & _
            "OPEN C1; " & _
            "SET RESULT SETS CURSOR C1; " & _
            "END "
   lstSPCmd.AddItem "Drop Procedure SQLTESTRS1"
   
   'Multiple result sets
   lstSPCmd.AddItem "Create Procedure SQLTESTRS2 ()RESULT SET 2 LANGUAGE SQL " & _
                     "SQLTestSrc: " & _
                     "BEGIN " & _
                     "DECLARE C1 CURSOR FOR SELECT * FROM CUSTCDT; " & _
                     "DECLARE C2 CURSOR FOR SELECT * FROM QCUSTCDT; " & _
                     "OPEN C1; OPEN C2; " & _
                     "SET RESULT SETS CURSOR C1,  CURSOR C2; " & _
                     "END"
   lstSPCmd.AddItem "Drop Procedure SQLTESTRS2"
   
   'Dynamic SQL
   lstSPCmd.AddItem "Create Procedure SQLTESTRS3 (IN SQLStmt CHAR(512)) RESULT SET 1 LANGUAGE SQL " & _
            "SQLTestSrc: " & _
            "BEGIN " & _
            "DECLARE C1 CURSOR for S1; " & _
            "PREPARE S1 FROM SQLStmt; " & _
            "OPEN C1; " & _
            "SET RESULT SETS CURSOR C1; " & _
            "END "
   lstSPCmd.AddItem "Drop Procedure SQLTESTRS3"
   
   'Temporary work table example, Dynamic SQL
   '"--Cannot use constraints on a table in QTEMP "
   lstSPCmd.AddItem "Create Procedure SQLTEST4 (IN TableName CHAR(20))LANGUAGE SQL " & _
            "SQLTestSrc: " & _
            "BEGIN " & _
            "DECLARE  sSQL CHAR(512); " & _
            "SET sSQL = 'CREATE TABLE QTEMP.'||TableName||' (f1 integer, f2 char(10))'; " & _
            "PREPARE S1 FROM sSQL; " & _
            "EXECUTE S1; " & _
            "END "
   lstSPCmd.AddItem "Drop Procedure SQLTEST4"
      
   'Cannot qualify the parameter/field/host variable on the last insert...
   lstSPCmd.AddItem "Create Procedure SQLTEST5 (IN parm1 int) LANGUAGE SQL " & _
      "test5: " & _
      "BEGIN " & _
         "DECLARE col2 int DEFAULT 2; " & vbCrLf & _
         "DECLARE dummy int;" & vbCrLf & _
         "DECLARE CONTINUE HANDLER FOR SQLSTATE '42704' SET dummy = 1; " & vbCrLf & _
         "DROP TABLE SQL5TESTB; " & vbCrLf & _
         "DROP TABLE SQL5TESTA; " & vbCrLf & _
         "CREATE TABLE SQL5TESTB (col1 char(10), col2 char(5), col3 integer); " & vbCrLf & _
         "CREATE TABLE SQL5TESTA (col1 char(10), col2 integer, col3 integer); " & vbCrLf & _
         "INSERT INTO SQL5TESTB VALUES( '1234567890', '01234', 1); " & vbCrLf & _
         "INSERT INTO SQL5TESTB VALUES( '2345678901', '12345', 2); " & vbCrLf & _
         "INSERT into SQL5TESTA select col1, col2, parm1 from SQL5TESTB; " & vbCrLf & _
         "END test5                 "
      '"-- Create work tables for example;
      lstSPCmd.AddItem "Drop Procedure SQLTEST5"
   
   lstSPCmd.AddItem "Create Procedure SQLTEST6 (INOUT parm1 decimal, OUT parm2 char(10)) LANGUAGE SQL " & _
   "Case parm1 " & vbCrLf & _
      "when 1 then set parm1 = 2; " & _
      "   set parm2 = '1111122222'; " & _
      "when 2 then set parm1 = 3; " & _
      "   set parm2 = '2222233333'; " & _
   "end case "
   lstSPCmd.AddItem "Drop Procedure SQLTEST6"
   
   
   S = "Create Procedure SQLTEST7 (INOUT parm1 decimal, " & vbCrLf & _
                  " INOUT parm2 char(10), INOUT parm3 float, INOUT parm4 VarChar(20), " & vbCrLf & _
                  " INOUT parm5 INTEGER, INOUT parm6 NUMERIC(8,1), " & vbCrLf & _
                  "INOUT parm7 DATE, INOUT parm8 TIME, INOUT parm9 TIMESTAMP, " & vbCrLf & _
                  "INOUT parm10 VARCHAR(512) for Bit data) " & vbCrLf & _
                  " LANGUAGE SQL " & vbCrLf
   S = S & _
   "Case parm1 " & vbCrLf & _
      "when 1 then set parm1 = 2; " & vbCrLf & _
      "   set parm2 = '1111122222'; " & vbCrLf & _
      "   set parm3 = parm1 * 2.5; " & vbCrLf & _
      "   set parm4 = '11111222221111122222'; " & vbCrLf & _
      "   set parm5 = parm1 + 1; " & vbCrLf & _
      "   set parm6 = (parm1 + 1) * .1; " & vbCrLf & _
      "   set parm7 = CURDATE(); " & vbCrLf & _
      "   set parm8 = CURTIME(); " & vbCrLf & _
      "   set parm9 = NOW(); " & vbCrLf & _
      "   set parm10 = X'000102030405060708090A0B0C0D0E'; " & vbCrLf
   S = S & _
      "when 2 then set parm1 = 3; " & vbCrLf & _
      "   set parm2 = '2222233333'; " & vbCrLf & _
      "   set parm3 = parm1 * 2.5; " & vbCrLf & _
      "   set parm4 = '23'; " & vbCrLf & _
      "   set parm5 = parm1 + 2; " & vbCrLf & _
      "   set parm6 = (parm1 + 2) * .1; " & vbCrLf & _
      "   set parm7 = CURDATE(); " & vbCrLf & _
      "   set parm8 = CURTIME(); " & vbCrLf & _
      "   set parm9 = NOW(); " & vbCrLf & _
      "   set parm10 = X'0F000102030405060708090A0B0C0D0E'; " & vbCrLf
   S = S & "END CASE "
   lstSPCmd.AddItem S
   
   lstSPCmd.AddItem "Drop Procedure SQLTEST8"
   lstSPCmd.AddItem "Create Procedure SQLTEST8 (IN parm1 int) LANGUAGE SQL " & _
      "test8: " & _
      "BEGIN " & _
         "DECLARE col2 int DEFAULT 2; " & vbCrLf & _
         "DECLARE dummy int;" & vbCrLf & _
         "DECLARE CONTINUE HANDLER FOR SQLSTATE '42704' SET dummy = 1; " & vbCrLf & _
         "DROP TABLE TABLEDOESNOTEXIST; " & vbCrLf & _
         "DROP TABLE SQL5TESTA; " & vbCrLf & _
         "CREATE TABLE SQL5TESTB (col1 char(10), col2 char(5), col3 integer); " & vbCrLf & _
         "CREATE TABLE SQL5TESTA (col1 char(10), col2 integer, col3 integer); " & vbCrLf & _
         "INSERT INTO SQL5TESTB VALUES( '1234567890', '01234', 1); " & vbCrLf & _
         "INSERT INTO SQL5TESTB VALUES( '2345678901', '12345', 2); " & vbCrLf & _
         "INSERT into SQL5TESTA select col1, col2, parm1 from SQL5TESTB; " & vbCrLf & _
         "END test8                 "
      '"-- Create work tables for example;
      lstSPCmd.AddItem "Drop Procedure SQLTEST5"
   
   'R440 added support for SIGNAL (GOTO, RESIGNAL, etc).  You cannot return state
   ' or error text to the ODBC application.  Instead you receive CPF2419 SQL0438 not found...
   lstSPCmd.AddItem _
         " CREATE PROCEDURE SIGEX( ) " & vbCrLf & _
         "       LANGUAGE SQL   MODIFIES sql data " & vbCrLf & _
         " begin  " & vbCrLf & _
         "    DECLARE FEXISTS INT DEFAULT 0; " & vbCrlFl & _
         "    DECLARE SQLSTATE CHAR(5); " & vbCrLf & _
         "    DECLARE CONTINUE HANDLER FOR SQLSTATE '42710' SET FEXISTS = 1; " & vbCrLf & _
         "    SET FEXISTS = 0; " & vbCrLf & _
         "    create TABLE custcdt (f1 int); " & vbCrLf & _
         "    If FEXISTS = 1 Then " & vbCrLf & _
         "     SIGNAL SQLState 'I1111' SET MESSAGE_TEXT = 'ERROR CUSTCDT EXISTS'; " & vbCrLf & _
         "    Else " & vbCrLf & _
         "       SIGNAL SQLState 'I2222' SET MESSAGE_TEXT = 'ERROR CUSTCDT DID NOT EXIST'; " & vbCrLf & _
         "    end if; " & vbCrLf & _
         " End " & vbCrLf
   lstSPCmd.AddItem "DROP PROCEDURE SIGEX"
   
 End Sub


