VERSION 5.00
Begin VB.Form frmProcCol 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "SQLProcedureColumns API"
   ClientHeight    =   2895
   ClientLeft      =   1875
   ClientTop       =   1605
   ClientWidth     =   4935
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2895
   ScaleWidth      =   4935
   Begin VB.ComboBox cboOption 
      Height          =   315
      Left            =   2400
      Style           =   2  'Dropdown List
      TabIndex        =   9
      Top             =   1800
      Visible         =   0   'False
      Width           =   2175
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3000
      TabIndex        =   5
      Top             =   2400
      Width           =   975
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   960
      TabIndex        =   4
      Top             =   2400
      Width           =   975
   End
   Begin VB.ComboBox cboProcName 
      Height          =   315
      Left            =   2400
      TabIndex        =   3
      Top             =   1320
      Width           =   2175
   End
   Begin VB.ComboBox cboLibName 
      Height          =   315
      ItemData        =   "frmProcCol.frx":0000
      Left            =   2400
      List            =   "frmProcCol.frx":0002
      TabIndex        =   0
      Top             =   840
      Width           =   2175
   End
   Begin VB.Label lblOption 
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   1800
      Visible         =   0   'False
      Width           =   1935
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "SQL Names are case sensitive"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   7
      Top             =   360
      Width           =   4215
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Use <null pointer> to retrieve all tables or procedures"
      Height          =   255
      Left            =   480
      TabIndex        =   6
      Top             =   120
      Width           =   4095
   End
   Begin VB.Label lblTableProcedure 
      Caption         =   "Procedure Name:"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   1440
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Library/Schema Name:"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   960
      Width           =   1815
   End
End
Attribute VB_Name = "frmProcCol"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Combo1_Change()

End Sub


Private Sub cmdCancel_Click()
   CatalogReq.LibName = ""
   CatalogReq.ProcName = ""
   CatalogReq.Option = ""
   Hide
End Sub

Private Sub cmdOK_Click()
      CatalogReq.LibName = cboLibName.Text
      CatalogReq.ProcName = cboProcName.Text
      CatalogReq.Option = cboOption.Text
   Hide 'Unload Me
End Sub

Private Sub Form_Activate()
   Static LastTag As String
   
   'Leave last data in unless changes to new request
   If LastTag <> frmProcCol.Tag Then
      cboLibName.Clear
      cboProcName.Clear
      cboLibName.AddItem "<null pointer>"
      cboProcName.AddItem "<null pointer>"
      cboLibName.ListIndex = 0
      cboProcName.ListIndex = 0
   End If
   LastTag = frmProcCol.Tag
   
   If frmProcCol.Tag = "SQLStatistics API" Then
      Caption = frmProcCol.Tag
      lblTableProcedure = "Table Name"
      lblOption.Visible = True
      cboOption.Visible = True
      lblOption = "Unique Option"
      cboOption.Clear
      cboOption.AddItem "SQL_INDEX_UNIQUE"
      cboOption.AddItem "SQL_INDEX_ALL"
      cboOption.ListIndex = 0
   Else
      lblOption.Visible = False
      cboOption.Visible = False
   
      If frmProcCol.Tag = "SQLColumns API" Then
         Caption = frmProcCol.Tag
         lblTableProcedure = "Table/View Name"
      ElseIf frmProcCol.Tag = "SQLTables API" Then
         Caption = frmProcCol.Tag
         lblTableProcedure = "Table/View Name"
      ElseIf frmProcCol.Tag = "SQLProcedures API" Then
         Caption = frmProcCol.Tag
         lblTableProcedure = "Procedure Name"
      ElseIf frmProcCol.Tag = "SQLProcedureColumns API" Then
         Caption = frmProcCol.Tag
         lblTableProcedure = "Procedure Name"
      End If
   End If
   cboLibName.SetFocus
End Sub

