VERSION 5.00
Begin VB.Form frmSQLStmt 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Execute SQL Statement"
   ClientHeight    =   3945
   ClientLeft      =   4365
   ClientTop       =   3015
   ClientWidth     =   7950
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3945
   ScaleWidth      =   7950
   ShowInTaskbar   =   0   'False
   Begin VB.TextBox txtSQL 
      Height          =   1095
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   1080
      Width           =   7455
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   375
      Left            =   6240
      TabIndex        =   5
      Top             =   3360
      Width           =   1215
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "&Execute"
      Default         =   -1  'True
      Height          =   375
      Left            =   4440
      TabIndex        =   4
      Top             =   3360
      Width           =   1215
   End
   Begin VB.TextBox txtRC 
      Height          =   285
      Left            =   1440
      Locked          =   -1  'True
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   3450
      Width           =   2535
   End
   Begin VB.ComboBox cboSQL 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   2760
      Width           =   7455
   End
   Begin VB.Label Label2 
      Caption         =   "Command History:"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   2520
      Width           =   1935
   End
   Begin VB.Label Label1 
      Caption         =   "Return Code:"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   3480
      Width           =   1095
   End
   Begin VB.Label lblInstructions 
      Caption         =   $"frmSQLStmt.frx":0000
      Height          =   855
      Left            =   600
      TabIndex        =   1
      Top             =   120
      Width           =   6615
   End
End
Attribute VB_Name = "frmSQLStmt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cboSQL_Click()
   If cboSQL.ListIndex <> -1 Then
      txtSQL.Text = cboSQL.Text
   End If
   
End Sub

Private Sub cmdExecute_Click()
   Dim S As String
   Dim hStmt As Long
   Dim NumRS As Long
   Dim I As Long

   txtRC.Text = ""
    frmMain.StatusBar1.Panels.Item(1).Text = ""
   'Try to avoid adding same stmt ran twice
   If StrComp(txtSQL.Text, cboSQL.Text, 1) <> 0 Then
      'Add new item to the list
      cboSQL.AddItem txtSQL.Text  'cboSQL.Text
      cboSQL.ListIndex = cboSQL.ListCount - 1
   End If
   
   'Execute the statement
   rc = SQLAllocStmt(ghDbc, hStmt)
   If (rc <> SQL_SUCCESS And rc <> SQL_SUCCESS_WITH_INFO) Then
      PrintError ghDbc, 0
      txtRC.Text = Str(rc)
      Exit Sub
   End If

   Screen.MousePointer = vbHourglass
   
   
   rc = SQLExecDirect(hStmt, txtSQL.Text, SQL_NTS)
   If (rc = SQL_ERROR) Then GoTo errSQLExecute
   
   If InStr(1, txtSQL.Text, "SELECT", 1) > 0 Or _
      InStr(1, txtSQL.Text, "CALL", 1) > 0 Then
      rc = SQLGetStmtOption(hStmt, 1014, NumRS)  'CA specific option to get number of result sets
      I = 0
      Do
         I = I + 1
         GetDataAll (hStmt)
         rc = SQLMoreResults(hStmt)
         If rc = SQL_SUCCESS Then
            frmMain.Refresh
            Sleep (2000)
         End If
      Loop While rc = SQL_SUCCESS
   End If
      
   rc = SQLFreeStmt(hStmt, SQL_CLOSE)
   rc = SQLFreeStmt(hStmt, SQL_DROP)
   Screen.MousePointer = 0
   'Debug.Assert I = NumRS
   If I > 1 Then
      txtRC.Text = "Stmt ran sucessfully.  " & Str(I) & " result sets returned."
   Else
      txtRC.Text = "Stmt ran successfully"
   End If
   
   Exit Sub
   
errSQLExecute:
   Screen.MousePointer = 0
   PrintError2 ghDbc, hStmt
   rc = SQLFreeStmt(hStmt, SQL_DROP)
   txtRC.Text = "Stmt Failed"
End Sub

Private Sub cmdExit_Click()
   txtRC.Text = ""
   Hide              'Keep the last command run

End Sub


Private Sub Form_Load()
Dim S As String

S = "This will run SQLExecDirect on the SQL Statement typed in.  If a result"
S = S & "set is returned: " & vbCrLf
S = S & "   All columns will be bound using SQLBindColumn; " & vbCrLf
S = S & "   All data will be fetched using SQLFetch; " & vbCrLf
S = S & "   The data will be displayed in the ListView Control."

lblInstructions.Caption = S

cboSQL.AddItem "Call RSARRAY1C('abc')"
cboSQL.AddItem "select custcdt.cusnum, lstnam, orders.orderid, prodid, quantity from custcdt left outer join orders on custcdt.cusnum = orders.cusnum left outer join orderdetails on orders.orderid = orderdetails.orderid"
End Sub


Private Sub txtSQL_Change()
   txtRC.Text = ""
End Sub
